diff --git a/game/client/src/main/resources/shaders/lines.fsh b/game/client/src/main/resources/shaders/lines.fsh
index 8b8fb3a78..856034cf0 100644
--- a/game/client/src/main/resources/shaders/lines.fsh
+++ b/game/client/src/main/resources/shaders/lines.fsh
@@ -2,10 +2,10 @@
 out vec4 FragColor;
 
 in vec4 Color;
-uniform vec4 ucolor;
+uniform vec4 uColor;
 
 void main() {
-    FragColor = Color * ucolor;
+    FragColor = Color * uColor;
     if (FragColor.a < 0.1f) {
         discard;
     }
diff --git a/game/client/src/main/resources/shaders/lines.gsh b/game/client/src/main/resources/shaders/lines.gsh
index 811cb2e7a..9dfe7be05 100644
--- a/game/client/src/main/resources/shaders/lines.gsh
+++ b/game/client/src/main/resources/shaders/lines.gsh
@@ -8,8 +8,7 @@ in VS_OUT {
 
 out vec4 Color;
 
-uniform float viewWidth;
-uniform float viewHeight;
+uniform vec2 uViewPortSize;
 uniform float uLineWidth;
 
 void main()
@@ -17,8 +16,8 @@ void main()
     vec4 p1 = gl_in[0].gl_Position;
     vec4 p2 = gl_in[1].gl_Position;
 
-    vec2 dir    = normalize((p2.xy/p2.w - p1.xy/p1.w) * vec2(viewWidth, viewHeight));
-    vec2 offset = vec2(-dir.y, dir.x) * uLineWidth / vec2(viewWidth, viewHeight);
+    vec2 dir    = normalize((p2.xy/p2.w - p1.xy/p1.w) * uViewPortSize);
+    vec2 offset = vec2(-dir.y, dir.x) * uLineWidth / uViewPortSize;
 
     Color = gs_in[0].color;
     gl_Position = p1 + vec4(offset.xy * p1.w, 0.0, 0.0);
diff --git a/game/client/src/main/resources/shaders/lines.vsh b/game/client/src/main/resources/shaders/lines.vsh
index e88cd1228..828627c93 100644
--- a/game/client/src/main/resources/shaders/lines.vsh
+++ b/game/client/src/main/resources/shaders/lines.vsh
@@ -8,11 +8,15 @@ out VS_OUT {
 } vs_out;
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 void main() {
-    gl_Position = projection * view * model * vec4(aPos, 1);
+    gl_Position = matrices.projection * matrices.view * model * vec4(aPos, 1);
 
     vs_out.color = aColor;
 }
diff --git a/game/client/src/main/resources/shaders/particle.gsh b/game/client/src/main/resources/shaders/particle.gsh
index 00be1c410..fe109c241 100644
--- a/game/client/src/main/resources/shaders/particle.gsh
+++ b/game/client/src/main/resources/shaders/particle.gsh
@@ -15,28 +15,31 @@ out vec2 TexCoord;
 out vec2 Lightmap;
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 viewInv;
-uniform mat4 projection;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 void main() {
     Color = gs_in[0].color;
     Lightmap = gs_in[0].lightmap;
 
     TexCoord = gs_in[0].uv;
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + viewInv * vec4(-gs_in[0].scale,  gs_in[0].scale, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + matrices.viewInv * vec4(-gs_in[0].scale,  gs_in[0].scale, 0.0, 0.0));
     EmitVertex();
 
     TexCoord = gs_in[0].uv + vec2(0, gs_in[0].uvSizes.y);
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + viewInv * vec4(-gs_in[0].scale, -gs_in[0].scale, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + matrices.viewInv * vec4(-gs_in[0].scale, -gs_in[0].scale, 0.0, 0.0));
     EmitVertex();
 
     TexCoord = gs_in[0].uv + vec2(gs_in[0].uvSizes.x, 0);
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + viewInv * vec4( gs_in[0].scale,  gs_in[0].scale, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + matrices.viewInv * vec4( gs_in[0].scale,  gs_in[0].scale, 0.0, 0.0));
     EmitVertex();
 
     TexCoord = gs_in[0].uv + gs_in[0].uvSizes;
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + viewInv * vec4( gs_in[0].scale, -gs_in[0].scale, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + matrices.viewInv * vec4( gs_in[0].scale, -gs_in[0].scale, 0.0, 0.0));
     EmitVertex();
 
     EndPrimitive();
diff --git a/game/client/src/main/resources/shaders/particle.vsh b/game/client/src/main/resources/shaders/particle.vsh
index 429cab385..f9bbfcdcd 100644
--- a/game/client/src/main/resources/shaders/particle.vsh
+++ b/game/client/src/main/resources/shaders/particle.vsh
@@ -14,10 +14,6 @@ out VS_OUT {
     vec2 lightmap;
 } vs_out;
 
-uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
-
 void main() {
     gl_Position = vec4(aPos, 1);
 
diff --git a/game/client/src/main/resources/shaders/post/showdepth.fsh b/game/client/src/main/resources/shaders/post/showdepth.fsh
index bc1360925..b9a62f6d9 100644
--- a/game/client/src/main/resources/shaders/post/showdepth.fsh
+++ b/game/client/src/main/resources/shaders/post/showdepth.fsh
@@ -1,13 +1,14 @@
-#version 120
+#version 410
 
-uniform sampler2D depthtex0;
+out vec4 FragColor;
+in vec2 TexCoords;
 
-varying vec2 texcoord;
+uniform sampler2D depthtex0;
 
 void main(){
-	float depth = texture(depthtex0, texcoord).r;
+	float depth = texture(depthtex0, TexCoords).r;
 	
 	depth = pow(depth, 1000);
 	
-	gl_FragColor = vec4(depth, depth, depth, 1.0);
+	FragColor = vec4(depth, depth, depth, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/post/showdepth.vsh b/game/client/src/main/resources/shaders/post/showdepth.vsh
index 9c7ba53f5..bceceacef 100644
--- a/game/client/src/main/resources/shaders/post/showdepth.vsh
+++ b/game/client/src/main/resources/shaders/post/showdepth.vsh
@@ -1,9 +1,10 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
 void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+    TexCoords = aTexCoords;
+    gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/world.fsh b/game/client/src/main/resources/shaders/world.fsh
index 9d9f5081b..e4ecc285d 100644
--- a/game/client/src/main/resources/shaders/world.fsh
+++ b/game/client/src/main/resources/shaders/world.fsh
@@ -5,55 +5,71 @@ out vec4 FragColor;
 in vec4 Color;
 in vec2 TexCoord;
 in vec2 LightMapCoord;
-in float Distance;
 in vec3 Light;
 
-uniform vec4 ucolor;
+uniform vec4 uColor;
+uniform vec2 uViewPortSize;
 
-uniform vec4 ufogColor;
-uniform int ufogMode;
-uniform float ufogStart;
-uniform float ufogEnd;
-uniform float ufogDensity;
+layout (std140) uniform FogState {
+    vec4 color;
+    int mode;
+    float start;
+    float end;
+    float density;
+} fogState;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 uniform sampler2D texture0;
 uniform sampler2D texture1;
 
+float distance() {
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+    fragPos /= fragPos.w;
+
+    return length(fragPos.xyz);
+}
+
 // Taken from https://github.com/hughsk/glsl-fog
 float fogFactorLinear() {
-    return 1.0 - clamp(((ufogEnd - (Distance)) / (ufogEnd - ufogStart)), 0.0, 1.0);
+    return 1.0 - clamp(((fogState.end - (distance())) / (fogState.end - fogState.start)), 0.0, 1.0);
 }
 
 float fogFactorExp() {
-    return 1.0 - clamp(exp(-ufogDensity * (Distance)), 0.0, 1.0);
+    return 1.0 - clamp(exp(-fogState.density * (distance())), 0.0, 1.0);
 }
 
 float fogFactorExp2() {
     float LOG2 = -1.442695;
-    float d = ufogDensity * (Distance);
+    float d = fogState.density * (distance());
     return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
 }
 
 
 vec4 computeFog(vec4 color) {
     float f = 0;
-    if (ufogMode == 0) { // Linear
+    if (fogState.mode == 0) { // Linear
         f = fogFactorLinear();
     }
-    else if (ufogMode == 1) { // EXP
+    else if (fogState.mode == 1) { // EXP
         f = fogFactorExp();
     }
-    else if (ufogMode == 2) { // EXP2
+    else if (fogState.mode == 2) { // EXP2
         f = fogFactorExp2();
     }
-    return vec4(mix(color.rgb, ufogColor.rgb, f), color.a);
+    return vec4(mix(color.rgb, fogState.color.rgb, f), color.a);
 }
 
 void main() {
     vec4 lightColor = texture(texture1, LightMapCoord);
     vec4 texColor = texture(texture0, TexCoord);
 
-    vec4 oColor = texColor * lightColor * Color * ucolor;
+    vec4 oColor = texColor * lightColor * Color * uColor;
     vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
 
     vec4 fColor = computeFog(litColor);
diff --git a/game/client/src/main/resources/shaders/world.vsh b/game/client/src/main/resources/shaders/world.vsh
index 97d6d3f8e..fdc0c5a29 100644
--- a/game/client/src/main/resources/shaders/world.vsh
+++ b/game/client/src/main/resources/shaders/world.vsh
@@ -8,7 +8,6 @@ layout (location = 4) in vec3 aNormal;
 out vec4 Color;
 out vec2 TexCoord;
 out vec2 LightMapCoord;
-out float Distance;
 out vec3 Light;
 
 uniform mat4 normalTransform;
@@ -17,20 +16,22 @@ uniform vec4 lightSourcePosition[];
 uniform vec4 lightSourceDiffuse[];
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 void main() {
     vec4 p = vec4(aPos, 1);
-    gl_Position = projection * view * model * p;
+    gl_Position = matrices.projection * matrices.view * model * p;
 
     TexCoord = aUV;
     Color = aColor;
     LightMapCoord = aLightmap;
 
-    // Used for the radial fog in shader
-    Distance = length((view * model * p).xyz);
-
     vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
     float dir1 = max(0.0f, dot(norm, lightSourcePosition[0]));
     float dir2 = max(0.0f, dot(norm, lightSourcePosition[1]));
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
index b1c7abc79..db184f2c9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -21,14 +20,14 @@ import java.util.Random;
 public class IceFloeLargeFeature
     extends LargeFeature {
     private @Nullable PerlinNoise perlinNoise = null;
-    private @Nullable PerlinNoise heightPerlinNoise = null;
+    private @Nullable PerlinNoise scalePerlinNoise = null;
     private @Nullable World lastWorld = null;
 
     @Override
     protected void doGeneration(@NotNull final World world, @NotNull final Random random, final int chunkX, final int chunkZ, final int baseChunkX, final int baseChunkZ, @NotNull final ChunkGeneratorResult result) {
-        if (this.perlinNoise == null || this.heightPerlinNoise == null || this.lastWorld != world) {
+        if (this.perlinNoise == null || this.scalePerlinNoise == null || this.lastWorld != world) {
             this.perlinNoise = new PerlinNoise(world.getRandomSeed(), 4);
-            this.heightPerlinNoise = new PerlinNoise(world.getRandomSeed(), 8);
+            this.scalePerlinNoise = new PerlinNoise(world.getRandomSeed(), 2);
             this.lastWorld = world;
         }
 
@@ -44,11 +43,13 @@ public class IceFloeLargeFeature
                 tilePos.set(Chunk.CHUNK_SIZE_X * baseChunkX + x, oceanY, Chunk.CHUNK_SIZE_Z * baseChunkZ + z);
                 final @NotNull Biome biome = world.getBlockBiome(tilePos);
                 if (biome == Biomes.OVERWORLD_GLACIER) {
-                    vec.x = baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X);
-                    vec.y = baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z);
+                    final float worleyScaleScale = 50.0f;
+                    final float worleyScale = 0.875f + (float) (this.scalePerlinNoise.getNormalized((baseChunkX * Chunk.CHUNK_SIZE_X + x) / worleyScaleScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / worleyScaleScale)) * 0.25f;
+                    vec.x = (baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X)) * worleyScale;
+                    vec.y = (baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z)) * worleyScale;
                     WorleyNoise.getWorleyDistance2d(vec, worley);
-                    final float scale = 10.0f;
-                    final float lineWidth = (float) (this.perlinNoise.get((baseChunkX * Chunk.CHUNK_SIZE_X + x) / scale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / scale) / 2.0 + 0.5);
+                    final float lineScale = 10.0f;
+                    final float lineWidth = (float) (this.perlinNoise.get((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
                     if (MathHelper.unsignedMod(worley.index, 15) != 0) {
                         if (worley.distance > 0.9f + lineWidth * 0.05f) {
                             continue;
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java
index 0301eeb7d..00d57e28d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/BaseImprovedNoise.java
@@ -1,91 +1,120 @@
 package net.minecraft.core.world.noise;
 
+import org.jetbrains.annotations.NotNull;
+
 import java.util.Random;
 
-public abstract class BaseImprovedNoise
-{
-    protected final int[] p;
+// Derived from Ken Perlin's Improved Noise reference implementation: https://cs.nyu.edu/~perlin/noise/
+public abstract class BaseImprovedNoise {
+    protected final int @NotNull [] p;
     public final double xo;
     public final double yo;
     public final double zo;
 
-    public BaseImprovedNoise(Random random) {
+    public BaseImprovedNoise(final @NotNull Random random) {
         this.p = new int[512];
         this.xo = random.nextDouble() * 256;
         this.yo = random.nextDouble() * 256;
         this.zo = random.nextDouble() * 256;
 
         // Assign initial values for each permutation
-        for (int i = 0; i < 256; i++)
-        {
-            p[i] = i;
+        for (int i = 0; i < 256; i++) {
+            this.p[i] = i;
         }
 
         // Shuffle values
-        for(int i = 0; i < 256; i++)
-        {
-            int newI = random.nextInt(256 - i) + i;
-            int temp = this.p[i];
+        for (int i = 0; i < 256; i++) {
+            final int newI = random.nextInt(256 - i) + i;
+            final int temp = this.p[i];
             this.p[i] = this.p[newI];
             this.p[newI] = temp;
             this.p[i + 256] = this.p[i];
         }
     }
 
-    public double getValue(double x, double y)
-    {
+    public double getValue(final double x, final double y) {
         return this.getValue(x, y, 0);
     }
 
-    public double getValue(double x, double y, double z)
-    {
-        int X = (int)((long)Math.floor(x) & 255),                  // FIND UNIT CUBE THAT
-            Y = (int)((long)Math.floor(y) & 255),                  // CONTAINS POINT.
-            Z = (int)((long)Math.floor(z) & 255);
-        x -= Math.floor(x);                                // FIND RELATIVE X,Y,Z
-        y -= Math.floor(y);                                // OF POINT IN CUBE.
+    public double getValue(double x, double y, double z) {
+        // Find unit cube that contains point
+        final int X = (int) Math.floor(x) & 255;
+        final int Y = (int) Math.floor(y) & 255;
+        final int Z = (int) Math.floor(z) & 255;
+
+        // Find relative XYZ of point in cube
+        x -= Math.floor(x);
+        y -= Math.floor(y);
         z -= Math.floor(z);
-        double u = fade(x),                                // COMPUTE FADE CURVES
-               v = fade(y),                                // FOR EACH OF X,Y,Z.
-               w = fade(z);
-        int A = p[X  ]+Y, AA = p[A]+Z, AB = p[A+1]+Z,      // HASH COORDINATES OF
-            B = p[X+1]+Y, BA = p[B]+Z, BB = p[B+1]+Z;      // THE 8 CUBE CORNERS,
-
-        return lerp(w, lerp(v, lerp(u, grad(p[AA  ], x  , y  , z   ),  // AND ADD
-                                                            grad(p[BA  ], x-1, y  , z   )), // BLENDED
-                                             lerp(u, grad(p[AB  ], x  , y-1, z   ),  // RESULTS
-                                                            grad(p[BB  ], x-1, y-1, z   ))),// FROM  8
-                              lerp(v, lerp(u, grad(p[AA+1], x  , y  , z-1 ),  // CORNERS
-                                                            grad(p[BA+1], x-1, y  , z-1 )), // OF CUBE
-                                             lerp(u, grad(p[AB+1], x  , y-1, z-1 ),
-                                                         grad(p[BB+1], x-1, y-1, z-1 ))));
+
+        // Compute fade curves for each of X, Y, and Z
+        final double u = this.fade(x);
+        final double v = this.fade(y);
+        final double w = this.fade(z);
+
+        // Hash coordinates of the 8 cube corners
+        final int A  = this.p[X    ] + Y;
+        final int AA = this.p[A    ] + Z;
+        final int AB = this.p[A + 1] + Z;
+        final int B =  this.p[X + 1] + Y;
+        final int BA = this.p[B    ] + Z;
+        final int BB = this.p[B + 1] + Z;
+
+        // Add blended results from 8 corners of the cube
+        return this.lerp(
+            w,
+            this.lerp(
+                v,
+                this.lerp(
+                    u,
+                    this.grad(this.p[AA], x, y, z),
+                    this.grad(this.p[BA], x - 1, y, z)
+                ),
+                this.lerp(
+                    u,
+                    this.grad(this.p[AB], x, y - 1, z),
+                    this.grad(this.p[BB], x - 1, y - 1, z)
+                )
+            ),
+            this.lerp(
+                v,
+                this.lerp(
+                    u,
+                    this.grad(this.p[AA + 1], x, y, z - 1),
+                    this.grad(this.p[BA + 1], x - 1, y, z - 1)),
+                this.lerp(
+                    u,
+                    this.grad(this.p[AB + 1], x, y - 1, z - 1),
+                    this.grad(this.p[BB + 1], x - 1, y - 1, z - 1)
+                )
+            )
+        );
     }
 
-    protected double grad(int hash, double x, double y)
-    {
-        int j = hash & 0xf;
-        double d2 = (double)(1 - ((j & 8) >> 3)) * x;
-        double d3 = j >= 4 ? j != 12 && j != 14 ? y : x : 0.0D;
-        return ((j & 1) != 0 ? -d2 : d2) + ((j & 2) != 0 ? -d3 : d3);
+    protected double grad2(final int hash, final double x, final double y) {
+        final int h = hash & 15;
+        final double u = (double) (1 - ((h & 8) >> 3)) * x;
+        final double v = h < 4 ? 0.0D : h == 12 || h == 14 ? x : y;
+
+        return ((h & 1) != 0 ? -u : u) + ((h & 2) != 0 ? -v : v);
     }
 
-    protected double fade(double t)
-    {
+    protected double fade(final double t) {
         return t * t * t * (t * (t * 6 - 15) + 10);
     }
 
-    protected double lerp(double t, double a, double b)
-    {
+    protected double lerp(final double t, final double a, final double b) {
         return a + t * (b - a);
     }
 
-    protected double grad(int hash, double x, double y, double z)
-    {
-        int h = hash & 15;                      // CONVERT LO 4 BITS OF HASH CODE
-        double u = h<8 ? x : y,                 // INTO 12 GRADIENT DIRECTIONS.
-                v = h<4 ? y : h==12||h==14 ? x : z;
-        return ((h&1) == 0 ? u : -u) + ((h&2) == 0 ? v : -v);
+    protected double grad(final int hash, final double x, final double y, final double z) {
+        // Converts low 4 bits of hash code into 12 gradient directions.
+        final int h = hash & 15;
+        final double u = h < 8 ? x : y;
+        final double v = h < 4 ? y : h == 12 || h == 14 ? x : z;
+
+        return ((h & 1) == 0 ? u : -u) + ((h & 2) == 0 ? v : -v);
     }
 
-    public abstract void add(double[] arr, double x, double y, double z, int xSize, int ySize, int zSize, double xScale, double yScale, double zScale, double levelScale);
+    public abstract void add(double[] out, double x, double y, double z, int xSize, int ySize, int zSize, double xScale, double yScale, double zScale, double valueScale);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java
index 6657ee29f..578e223c0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java
@@ -6,8 +6,11 @@ import java.util.Random;
 public abstract class BasePerlinNoise<T extends BaseImprovedNoise>
     extends SurfaceNoise
 {
+    private static final double MAX_2D = Math.sqrt(2.0 / 4.0);
+
     private final T[] octaves;
     private final int numOctaves;
+    final double maxValue;
 
     public BasePerlinNoise(long seed, int numOctaves)
     {
@@ -31,6 +34,15 @@ public abstract class BasePerlinNoise<T extends BaseImprovedNoise>
         }
         this.numOctaves = numOctaves;
         this.octaves = newOctaves(random, numOctaves);
+
+        double maxValue = 0.0;
+        double levelScale = 1.0;
+        for (int i = 0; i < this.numOctaves; i++) {
+            maxValue += MAX_2D / levelScale;
+            levelScale /= 2.0;
+        }
+
+        this.maxValue = maxValue;
     }
 
     protected abstract T[] newOctaves(Random random, int numOctaves);
@@ -49,6 +61,18 @@ public abstract class BasePerlinNoise<T extends BaseImprovedNoise>
         return out;
     }
 
+    public double getNormalized(double x, double y) {
+        final double value = this.get(x, y);
+
+        // Map to +-1.0
+        double workingValue = value / this.maxValue;
+
+        // Map to 0.0-1.0
+        workingValue = 0.5 + (workingValue / 2.0);
+
+        return workingValue;
+    }
+
     public double[] get(double[] noiseArray, double x, double y, double z,
                         int xSize, int ySize, int zSize, double scaleX, double scaleY,
                         double scaleZ)
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/BetaPerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/BetaPerlinNoise.java
index a117b2687..60b83da3b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/BetaPerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/BetaPerlinNoise.java
@@ -3,7 +3,7 @@ package net.minecraft.core.world.noise;
 import java.util.Random;
 
 public class BetaPerlinNoise
-    extends BasePerlinNoise<BetaImprovedNoise>
+    extends BasePerlinNoise<ImprovedNoise>
 {
     public BetaPerlinNoise(final long seed, final int numOctaves) {
         super(seed, numOctaves);
@@ -14,11 +14,11 @@ public class BetaPerlinNoise
     }
 
     @Override
-    protected BetaImprovedNoise[] newOctaves(final Random random, final int numOctaves) {
-        BetaImprovedNoise[] levels = new BetaImprovedNoise[numOctaves];
+    protected ImprovedNoise[] newOctaves(final Random random, final int numOctaves) {
+        ImprovedNoise[] levels = new ImprovedNoise[numOctaves];
 
         for (int i = 0; i < numOctaves; i++) {
-            levels[i] = new BetaImprovedNoise(random);
+            levels[i] = new ImprovedNoise(random, LegacyNoiseType.BETA);
         }
 
         return levels;
